function tw = texture_weights(fin,sigma)

   vareps = 0.001;

   fbin = lpfilter(fin, sigma); % smoothed image
   gfx = diff(fbin,1,2); % x-derivative of smoothed image
   gfx = padarray(gfx, [0 1], 'post');
   gfy = diff(fbin,1,1); % y-derivative of smoothed image
   gfy = padarray(gfy, [1 0], 'post');  
      
   wtbx = max(sum(abs(gfx),3)/size(fin,3),vareps); 
   wtby = max(sum(abs(gfy),3)/size(fin,3),vareps);  
   tw = wtbx+wtby;
   tw = tw./max(tw(:));
end

function ret = conv2_sep(im, sigma)
  ksize = bitor(round(5*sigma),1);
  g = fspecial('gaussian', [1,ksize], sigma); 
  ret = conv2(im,g,'same');
  ret = conv2(ret,g','same');  
end

function FBImg = lpfilter(FImg, sigma)     
    FBImg = FImg;
    for ic = 1:size(FBImg,3)
        FBImg(:,:,ic) = conv2_sep(FImg(:,:,ic), sigma);
    end   
end
